# (tmb) temp disable doc
%define build_doc 0

# (wally) exclude plugin .so from provides
%global __provides_exclude_from %{_libdir}/libnl/.*\\.so

%define api	3
%define major	200
%define libname	%mklibname nl %{api} %{major}
%define devname	%mklibname nl %{api} -d

%define libcli		%mklibname nl-cli %{api} %{major}
%define libgenl		%mklibname nl-genl %{api} %{major}
%define libidiag	%mklibname nl-idiag %{api} %{major}
%define libnf		%mklibname nl-nf %{api} %{major}
%define libroute	%mklibname nl-route %{api} %{major}
%define libxfrm		%mklibname nl-xfrm %{api} %{major}

%define libnldir	%(echo libnl%{version}|sed -e 's/\\./_/g' -)

Summary:	A collection of libraries providing APIs to netlink protocol based kernel interfaces
Group:		System/Libraries
License:	LGPLv2
Name:		libnl3
Version:	3.10.0
Release:	%mkrel 1
URL:		https://www.infradead.org/~tgr/libnl/
Source:		https://github.com/thom311/libnl/releases/download/%{libnldir}/libnl-%{version}.tar.gz
BuildRequires:	flex
BuildRequires:	bison

%description
A collection of libraries providing APIs to netlink protocol based kernel
interfaces.

Netlink is a IPC mechanism primarily between the kernel and user space
processes. It was designed to be a more flexible successor to ioctl to
provide mainly networking related kernel configuration and monitoring
interfaces.

%package -n	%{libname}
Summary:	Shared libraries for %{name}
Group:		System/Libraries
Requires:	%{name}-config >= %{version}-%{release}
Obsoletes:	%{name} < 3.2.21

%description -n	%{libname}
Core library implementing the fundamentals required to use the netlink
protocol such as socket handling, message construction and parsing,
and sending and receiving of data. This library is kept small and
minimalistic.

%package -n	%{libcli}
Summary:	Shared library for %{name}
Group:		System/Libraries
Conflicts:	%{name} < 3.2.21

%description -n	%{libcli}
Command Line Interface library for netlink sockets.

%package -n	%{libgenl}
Summary:	Shared library for %{name}
Group:		System/Libraries
Conflicts:	%{name}	< 3.2.21

%description -n	%{libgenl}
API to the generic netlink protocol, an extended version of the netlink
protocol.

%package -n	%{libidiag}
Summary:	Shared library for %{name}

%description -n	%{libidiag}
Netlink Inet Diag Family Library.

%package -n	%{libnf}
Summary:	Shared library for %{name}
Conflicts:	%{name} < 3.2.21

%description -n	%{libnf}
API to netlink based netfilter configuration and monitoring interfaces
(conntrack, log, queue).

%package -n	%{libroute}
Summary:	Shared library for %{name}
Group:		System/Libraries
Conflicts:	%{name} < 3.2.21

%description -n	%{libroute}
API to the configuration interfaces of the NETLINK_ROUTE family including
network interfaces, routes, addresses, neighbours, and traffic control.

%package -n	%{libxfrm}
Summary:	Shared library for %{name}
Group:		System/Libraries

%description -n	%{libxfrm}
Netlink Routing Family Library.

%package -n	%{devname}
Summary:	Development files and headers for %{name}
Group:		System/Libraries
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libroute} = %{version}-%{release}
Requires:	%{libgenl} = %{version}-%{release}
Requires:	%{libidiag} = %{version}-%{release}
Requires:	%{libnf} = %{version}-%{release}
Requires:	%{libcli} = %{version}-%{release}
Requires:       %{libxfrm} = %{version}-%{release}
Requires:	kernel-headers
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-devel < 3.2.21

%description -n	%{devname}
This package contains the development files and headers for %{name}.

%package	config
Summary:	Name maps for %{name}
Group:		System/Libraries
BuildArch:	noarch
Conflicts:	%{name} < 3.2.21

%description	config
This package contains configuration files for %{name}.

%package	tools
Summary:	Command line utilities to directly work with Netlink
Group:		System/Libraries
Obsoletes:	%{name}-cli < 3.2.21

%description	tools
Various test program with which the functionality of %{name} is
demonstrated.

%if %build_doc
%package	doc
Summary:	API documentation for libnl3
Group:		System/Libraries
Requires:	%{name} = %{version}-%{release}
BuildArch:	noarch

%description	doc
This package contains libnl3 API documentation.
%endif

%prep
%setup -q -n libnl-%{version}
%autopatch -p1

%build
%configure --disable-static
%make_build

%if %build_doc
pushd doc
    # docs aren't parallel-make safe
    make gendoc
popd
%endif

%install
%make_install

# we don't want these
find %{buildroot} -name "*.la" -delete

%check
make check

%files -n %{libname}
%{_libdir}/libnl-%{api}.so.%{major}{,.*}

%files -n %{libgenl}
%{_libdir}/libnl-genl-%{api}.so.%{major}{,.*}

%files -n %{libidiag}
%{_libdir}/libnl-idiag-%{api}.so.%{major}{,.*}

%files -n %{libnf}
%{_libdir}/libnl-nf-%{api}.so.%{major}{,.*}

%files -n %{libroute}
%{_libdir}/libnl-route-%{api}.so.%{major}{,.*}

%files -n %{libxfrm}
%{_libdir}/libnl-xfrm-%{api}.so.%{major}{,.*}

%files -n %{libcli}
%{_libdir}/libnl-cli-%{api}.so.%{major}{,.*}
%dir %{_libdir}/libnl/
%dir %{_libdir}/libnl/cli/
%dir %{_libdir}/libnl/cli/cls
%dir %{_libdir}/libnl/cli/qdisc/
%{_libdir}/libnl/cli/cls/basic.so
%{_libdir}/libnl/cli/cls/cgroup.so
%{_libdir}/libnl/cli/qdisc/bfifo.so
%{_libdir}/libnl/cli/qdisc/blackhole.so
%{_libdir}/libnl/cli/qdisc/fq_codel.so
%{_libdir}/libnl/cli/qdisc/ingress.so
%{_libdir}/libnl/cli/qdisc/hfsc.so
%{_libdir}/libnl/cli/qdisc/htb.so
%{_libdir}/libnl/cli/qdisc/pfifo.so
%{_libdir}/libnl/cli/qdisc/plug.so

%files -n %{devname}
%{_includedir}/%{name}/
%{_libdir}/libnl-%{api}.so
%{_libdir}/libnl-cli-%{api}.so
%{_libdir}/libnl-genl-%{api}.so
%{_libdir}/libnl-idiag-%{api}.so
%{_libdir}/libnl-nf-%{api}.so
%{_libdir}/libnl-route-%{api}.so
%{_libdir}/libnl-xfrm-%{api}.so
%{_libdir}/pkgconfig/libnl-3.0.pc
%{_libdir}/pkgconfig/libnl-cli-3.0.pc
%{_libdir}/pkgconfig/libnl-genl-3.0.pc
%{_libdir}/pkgconfig/libnl-idiag-3.0.pc
%{_libdir}/pkgconfig/libnl-nf-3.0.pc
%{_libdir}/pkgconfig/libnl-route-3.0.pc
%{_libdir}/pkgconfig/libnl-xfrm-3.0.pc

%files config
%dir %{_sysconfdir}/libnl/
%config %{_sysconfdir}/libnl/classid
%config %{_sysconfdir}/libnl/pktloc

%files tools
%{_bindir}/*
%{_mandir}/man8/*.8.*

%if %build_doc
%files doc
%doc doc/*.html
%doc doc/*.css
%doc doc/stylesheets/*
%doc doc/images/*
%doc doc/images/icons/*
%doc doc/images/icons/callouts/*
%doc doc/api/*
%endif


%changelog
* Wed Aug 28 2024 mrambo3501 <mrambo3501> 3.10.0-1.mga10
+ Revision: 2091906
- version 3.10.0

* Thu Jul 14 2022 luigiwalser <luigiwalser> 3.7.0-1.mga9
+ Revision: 1868912
- 3.7.0

* Thu Mar 17 2022 umeabot <umeabot> 3.5.0-3.mga9
+ Revision: 1797091
- Mageia 9 Mass Rebuild

* Tue Feb 18 2020 umeabot <umeabot> 3.5.0-2.mga8
+ Revision: 1541793
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Thu Jan 02 2020 luigiwalser <luigiwalser> 3.5.0-1.mga8
+ Revision: 1475426
- 3.5.0

* Sun Sep 23 2018 umeabot <umeabot> 3.4.0-3.mga7
+ Revision: 1299051
- Mageia 7 Mass Rebuild

* Tue Dec 12 2017 ovitters <ovitters> 3.4.0-2.mga7
+ Revision: 1182297
- rebuild to fix gpg signature

* Sun Dec 10 2017 wally <wally> 3.4.0-1.mga7
+ Revision: 1181916
- new version 3.4.0

* Tue May 09 2017 luigiwalser <luigiwalser> 3.3.0-1.mga6
+ Revision: 1099879
- 3.3.0
- remove upstreamed patches

* Sun Apr 23 2017 luigiwalser <luigiwalser> 3.2.29-3.mga6
+ Revision: 1097113
- add upstream patch to fix CVE-2017-0553

* Sat Jan 21 2017 luigiwalser <luigiwalser> 3.2.29-2.mga6
+ Revision: 1082868
- add upstream patch(es) via fedora to fix CVE-2017-0386 and other issues

* Sun Jan 01 2017 luigiwalser <luigiwalser> 3.2.29-1.mga6
+ Revision: 1078971
- 3.2.29

* Mon Oct 03 2016 daviddavid <daviddavid> 3.2.28-3.mga6
+ Revision: 1058273
- fix another missing requires on the devel

* Wed Sep 28 2016 neoclust <neoclust> 3.2.28-2.mga6
+ Revision: 1057229
- Fix missing requires on the devel

* Thu Aug 11 2016 luigiwalser <luigiwalser> 3.2.28-1.mga6
+ Revision: 1045513
- 3.2.28
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Tue Dec 01 2015 luigiwalser <luigiwalser> 3.2.27-1.mga6
+ Revision: 907513
- 3.2.27
- update source URL
- simplify files list
- clean spec a bit

* Fri Aug 21 2015 tmb <tmb> 3.2.25-4.mga6
+ Revision: 867652
- rebuild for new gcc

* Wed Oct 15 2014 umeabot <umeabot> 3.2.25-3.mga5
+ Revision: 747295
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.2.25-2.mga5
+ Revision: 681656
- Mageia 5 Mass Rebuild

* Sun Jul 27 2014 wally <wally> 3.2.25-1.mga5
+ Revision: 657609
- new version 3.2.25

* Sat Feb 22 2014 wally <wally> 3.2.24-1.mga5
+ Revision: 595670
- new version 3.2.24

* Sat Oct 19 2013 umeabot <umeabot> 3.2.22-2.mga4
+ Revision: 530512
- Mageia 4 Mass Rebuild

* Wed Jul 24 2013 wally <wally> 3.2.22-1.mga4
+ Revision: 457849
- new version 3.2.22
- clean BRs

* Sun Jun 16 2013 wally <wally> 3.2.21-1.mga4
+ Revision: 443647
- new version 3.2.21
- fix libification
- drop upstream applied patch
- exclude plugin .so's from provides

* Sun May 12 2013 blino <blino> 3.2.17-3.mga3
+ Revision: 413022
- fix crash when user callback is not set (like with NetworkManager, #9734)

* Sat Jan 12 2013 umeabot <umeabot> 3.2.17-2.mga3
+ Revision: 357875
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 06 2013 tmb <tmb> 3.2.17-1.mga3
+ Revision: 339600
- update to 3.2.17

* Sat Nov 24 2012 luigiwalser <luigiwalser> 3.2.14-1.mga3
+ Revision: 321668
- 3.2.14
+ fwang <fwang>
- set doc as noarch

* Thu Oct 18 2012 fwang <fwang> 3.2.13-1.mga3
+ Revision: 307853
- new version 3.2.13

* Mon Aug 27 2012 tmb <tmb> 3.2.11-1.mga3
+ Revision: 284508
- update to 3.2.11

* Wed Mar 07 2012 tmb <tmb> 3.2.7-1.mga2
+ Revision: 220929
- fix groups
- disable docs for now (broken build)
- fix Group and BR
- spec cleanup
- import from fedora


* Fri Feb 10 2012 Dan Williams <dcbw@redhat.com> - 3.2.7-1
- Update to 3.2.7

* Tue Jan 17 2012 Jiri Pirko <jpirko@redhat.com> - 3.2.6-1
- Initial build
